/*
	Application Tab Projects
*/

var currentProjectList;
function GetProject(guid) {
	if(!currentProjectList)
		return null;
	
	var i, c = currentProjectList.length;
	for(i=0; i<c; i=i+1) {
		if(currentProjectList[i].valueForKey('uid') == guid) {
			return currentProjectList[i];
		}
	}
	return null;
}

function LayoutProjectUIList(projectsArray) {
	var rowTemplate = $('#ApplicationTabProjects #project-list-row-template');
	$('#project-list-content').empty();
	
	//Reference for various ui actions
	currentProjectList = projectsArray;
	
	var i, c = projectsArray.length;
	
		
	for(i=0; i<c; i=i+1) {	
		var project = projectsArray[i];
		//NSLog('layout next project:'+project.valueForKey('title'));
		
		var mrow = rowTemplate.clone().addClass('project_row').attr('id', project.valueForKey('uid'));
		mrow.appendTo($(document.getElementById('project-list-content'))).show();
		mrow.projRowTitle(project.valueForKey('title'));
		mrow.projRowPercent(project.valueForKey('percentComplete'));
		mrow.projRowCounts(project.valueForKey('incompleteCount'), project.valueForKey('dueCount'));
		mrow.projRowBind(project.valueForKey('uid'));
		
		var pstate = project.valueForKey('state');
		if(pstate && pstate == "filed") {
			mrow.find('#ical').setVisuallyRecessed()
		}
	}
}

function resyncIcalForProject(guid) {
	ProjectListController.resynciCalActionForProjectWithIdentifier_(guid);
}

function resyncDejumbleForProject(guid) {
	ProjectListController.resyncDejumbleActionForProjectWithIdentifier_(guid);
}

function closeProjectEditor() {
	$("#ApplicationTabProjects .project-info").remove();
	$("#ApplicationTabProjects .project_row").show();	
}

function m_configureEditorForProject(editor, guid) {
	var project = GetProject(guid);
	
	editor.attr('id', guid);
	editor.find('#project-title-field').text(project.valueForKey('title'));
	if(project.valueForKey('calSynced')) {
		editor.find('#project-ical-synced input').attr('checked', 'checked');
	}
	if(project.valueForKey('synced') && !project.valueForKey('calSynced')) {
		editor.find('#project-dejumble-synced input').attr('checked', 'checked');
	}
	var pstate = project.valueForKey('state');
	if(pstate && pstate == 'filed') {
		editor.find('#project-is-filed input').attr('checked', 'checked');
	}
}

function showEditorForProject(guid) {
	closeProjectEditor();
	
	//NSLog('should show editor for guid:'+guid);
	
	//1. Get the editor template
	var editor = $('#project-info-editor-template').clone().addClass('project-info');
	
	//2. Configure the editor for given project
	m_configureEditorForProject(editor, guid);
	
	//3. find the row to swap
	$("#ApplicationTabProjects .project_row.guid[id='"+guid+"']").hide().after(editor.show());
	
	//3. Focus the project title
	editor.find('#project-title-field').focus();
}

function filerProjectRowButtonClicked(element, guid) {
	//NSLog('filer clicked on:'+element+' for project:'+guid);
	if($(element).hasClass('enabled')) {
		filedStateChangedForProject('false', guid);
	} else {			
		filedStateChangedForProject('true', guid);
	}
}

function dueTaskBadgeClickedForProject(guid) {
	ProjectListController.filterDueActionForProjectWithIdentifier_(guid);
}

function incompleteTaskBadgeClickedForProject(guid) {
	ProjectListController.filterIncompleteActionForProjectWithIdentifier_(guid);
}

function followLinkClickedForProject(guid) {
	ProjectListController.followActionForProjectWithIdentifier_(guid);
}

// Editor Actions

function filedStateChangedForProject(state, guid) {
	var project = GetProject(guid);
	if(project) {
		//NSLog("new state for project:"+state+ " title:"+GetProject(guid).valueForKey('title'));
		var rowelement = $(".project_row.guid[id='"+guid+"'] #ical");
		//NSLog("found elements to update:"+rowelement.length);
		if(state == 'true' || state == true) {
			rowelement.setVisuallyRecessed();
			project.setValueForKey('filed', 'state');
		} else {
			rowelement.removeClass('enabled').find('.drop-shaddows').remove();
			project.setValueForKey('normal', 'state');
		}
		ProjectListController.projectFiledStateChanged_(guid);
	}
}

function icalSyncChangedForProject(state, guid) {
	var project = GetProject(guid);
	//NSLog('state:['+ state +'] for ical:'+project.valueForKey('calSynced'));
	if(state) {		
		if(project.valueForKey('calSynced') == false) {
			project.setValueForKey(true, 'calSynced');
			resyncIcalForProject(guid);
		}
		
	} else {
		project.setValueForKey(false, 'calSynced');
	}
}

function dejumbleSyncChangedForProject(state, guid) {
	var project = GetProject(guid);
	if(state) {		
		if(project.valueForKey('synced') == false) {
			project.setValueForKey(true, 'synced');
			resyncDejumbleForProject(guid);
		}
		
	} else {
		project.setValueForKey(false, 'synced');
	}
}

function titleChangedForProject(title, guid) {
	ProjectListController.projectEndTitleEditing_title_(guid, title);
	//GetProject(guid).setValueForKey(title, 'title');
}

function selectRowForProject(guid) {
	NSLog('selecting row:'+guid);
	ProjectListController.rowSelectionActionForProjectWithIdentifier_(guid);
}

// From Cocoa

function SetVisuallySelectedProject(guid) {
	$("#ApplicationTabProjects .guid").removeClass('selected');
	$("#ApplicationTabProjects .guid[id='"+guid+"']").addClass('selected');
}

/***************************************************
 JQuery plugins for automatic project row updates
***************************************************/

jQuery.fn.projRowBind = function(guid) {
	this.each(function() {
		$(this).find('.title_box .title')
		.attr('bnd', 'Project/'+guid);
	});
}

jQuery.fn.projRowTitle = function(title) {
	this.each(function() {
		$(this).find('.title_box .title').text(title);		
	});
};

jQuery.fn.projRowPercent= function(percent) {
	this.each(function() {
		$(this).find('.completion-background').css('width', (100*percent)+'%');
		if(percent > 0) {
			$(this).find('.completion-background').show();
		} else {
			$(this).find('.completion-background').hide();
		}
	});
};

jQuery.fn.projRowCounts = function(incomplete, due) {
	this.each(function() {
		if(due) {
			$(this).find('span.count').empty().append("<span class='due' onclick='dueTaskBadgeClickedForProject($(this).guid())'>"+due+"</span>"+
							"<span onclick='incompleteTaskBadgeClickedForProject($(this).guid())'>"+incomplete+"</span>");
		} else if(incomplete) {
			$(this).find('span.count').empty().append("<span class='incomplete' onclick='incompleteTaskBadgeClickedForProject($(this).guid())'>"+incomplete+"</span>");
		}
	});
}

jQuery.fn.projRowDue = function(date) {
	this.each(function() {
		$(this).find('.project-due').remove();
		
		if(date) {
			$(this).find('.count').after("<span class='project-due'>"+date.toString('MMM d')+"</span>");
		}
	});
}

jQuery.fn.projRowFiled = function(value) {
	this.each(function() {
		if(value == 1 || value == true) {
			$(this).find('span#ical').setVisuallyRecessed();
		} else {
			$(this).find('span#ical').removeClass('enabled').find('.drop-shaddows').remove();
		}
	});
}

jQuery.fn.setVisuallyRecessed = function() {
	this.each(function() {
		$(this).addClass('enabled').append(
				"<span class='drop-shaddows'>"+
					"<span class='recessed_n drop_left' style='bottom: -5px; -webkit-box-shadow: -2px 0px 5px #000;'></span>"+
					"<span class='recessed_n drop_right' style='bottom: -5px; -webkit-box-shadow: 2px 0px 5px #000;'></span>"+
					"<span class='recessed_n drop_top' style='right: 3px; -webkit-box-shadow: 0px -1px 5px #000;'></span>"+
					"<span class='recessed_n drop_bottom' style='right: 4px; -webkit-box-shadow: 0px 2px 5px #000;'></span>"+
				"</span>");
	});
}