/*
	guid() plugin for Dejumlbe.
	
	1. Its basically a short cut for $(this).closest(.guid).attr('id') for retreive parent guids
*/

jQuery.fn.guid = function() {
	var guid = null;
	this.each(function() {
		if($(this).hasClass('.guid')) {
			guid = $(this).attr('id');
		} else {
			guid = $(this).closest('.guid').attr('id');
		}
	});
	return guid;
};

//Check if 'all' are visible
jQuery.fn.isVisible = function() {
	var visible = true;
	this.each(function() {
		var displayCSS = $(this).css('display');
		if(displayCSS && displayCSS == 'none') {
			visible = false;
		}
	});
	return visible;
}

//Shows the upper area, usually used for adding items show above the smart-bar
jQuery.fn.upperArea = function(flag) {
	var messageBox = this.find('.message-area');
	var scrollView = this.find('.tab-context');
	var smartBar = this.find('.smart-bar');
	var upperArea = this.find('.upper-area');
	
	if(upperArea.length>0) {
		var visible = upperArea.isVisible();
		if(upperArea.isVisible() && flag == false) {
			if(messageBox.isVisible()) {
				scrollView.animate({top:smartBar.height()+messageBox.innerHeight()+1});
			} else {
				scrollView.animate({top:smartBar.height()+1});
			}
			upperArea.slideUp();
		} else if(!visible) {
			var upperAreaHeight = upperArea.innerHeight();
			upperArea.slideDown();
			if(messageBox.isVisible()) {
				scrollView.animate({top:upperAreaHeight+smartBar.height()+messageBox.innerHeight()+1});
			} else {
				scrollView.animate({top:upperAreaHeight+smartBar.height()+1});
			}
			
		}
	}
}

//Shows the message area under the smart bar. Works on the application task tab name
jQuery.fn.messageBox = function(flag) { 
	var messageBox = this.find('.message-area');
	var scrollView = this.find('.scroll-view');
	var smartBar = this.find('.smart-bar');
	if(messageBox.length>0) {
		var sh = smartBar.height();
		var visible = messageBox.isVisible();
		if(flag == false && visible) { //Hide
			messageBox
			.animate({top:-(messageBox.outerHeight()-sh)}, function() {
				$(this).hide();
			});
			scrollView
			.animate({top:smartBar.height()+smartBar.offset().top - 1});
		} else if(!visible) {			//Show
			messageBox
			.css({top:-(messageBox.outerHeight()-sh)})
			.show()
			.animate({top:smartBar.height()});
			scrollView
			.animate({top:(scrollView.offset().top + messageBox.height() + (messageBox.outerHeight() - sh - 1))});
			
			//Provides the close action if contains a child with a .close class
			var that = this;
			$(this).find('.close').click(function() {
				$(that).messageBox(false);
			});
		}
	}
}

/* 
	This can be used in onkeypress='ReturnFiresChange(element, event)' 
	to block return from doing newlines, and to fire the change action 
*/
function ReturnFiresChange(element, event) {
	if(event.keyCode == 13) {
		$(element).blur();
		event.stopPropagation();
		event.preventDefault();
		return false;
	}
}